# Assets -- A:Aktien, B:Bonds
A <- 1; B <-2
Assets <- c(10,90)
Liabilities <- 80
RTK <- sum(Assets)-sum(Liabilities)

#Risikofaktoren -- Z:Zins, I:(Aktien)Index, S:Storno
Z <- 1; I <- 2; S <- 3
# BestEstimateStorno ist unbedeutend, 
# der Wert hebt sich in den Formeln weg
BestEstimateStorno <- 123
Delta <- c(0.0001,0.1*Assets[A],0.1*BestEstimateStorno)
DeltaRTK <-  c(Delta[Z]*(-5*Assets[B]+10*Liabilities),
               Delta[I]*Assets[A],
               -0.05)
Dg <- t(DeltaRTK/Delta);

volX <- c(0.0125,0.25,BestEstimateStorno)
corr <- array(c(1,-0.25,0,-0.25,1,0,0,0,1),c(3,3))
varDeltaRTK <- ( Dg
                %*% (corr * (volX %*% t(volX)))
                %*% t(Dg) )

p1 <- 0.005
K <- 5
c1 <- 20
KonfNiveau <- 0.99
FRoot <- function(x,a){
  ((1-p1)*pnorm(x,K,sqrt(varDeltaRTK))
   + p1*pnorm(x,K+c1,sqrt(varDeltaRTK))-KonfNiveau)
}
xF <- function(x){
  x*((1-p1)*dnorm(x,K,sqrt(varDeltaRTK))
     + p1*dnorm(x,K+c1,sqrt(varDeltaRTK)))
}
x0 <- uniroot(FRoot,
              lower=0,
              upper=1E6,
              tol=0.000001)$root
ES <- integrate(xF,x0,Inf)$value/(1-KonfNiveau)
print(paste("Das Risikokapital ohne MVM ist ",
            "damit C0 = ",
            ES,
            sep=""))

